#!/usr/bin/perl

#
# Author: kenshinjeff 
# Page: http://kenshinjeff.jp/tag/xexun/
# Date: 2011 09 29
# Version 0.9 
# 
# Please feel free to redistribute/modify this script. 
# I was using this for my cloned xexun tk102, you just need to change a few 
# variables for it to work with any cloned/original xexun. 
# 
# This is a copy paste hack modified perl script. Can't really program in perl 
# for nuts, I'm sure there's a much better way of doing #stuff, but this works
# for me and I have move on to doing other stuff. Good luck implmenting this. 
#

use threads;
use IO::Socket;
use DBI;

$SIG{CHLD} = 'IGNORE';
$| = 1;

my $server = new IO::Socket::INET ( LocalAddr => '1.2.3.4', LocalPort => '7777', Proto => 'tcp', Listen => 1, Reuse => 1  );

die "Could not create socket: $!\n" unless $server;
my $new_sock;
while( $new_sock = $server->accept() ) {
	print "got a connection at: " . localtime() . ", ip: " . $new_sock->peerhost() . "\n";
	my $pid;
	die "can't fork: $!" unless defined ($pid = fork()); 
	print "pid is " . $pid . "\n";

	if ($pid == 0) {
		#close the child's listen connection
		$server->close;
		my $readlen = 50;
		my $buf1, $tmpStr;
		CHUNK: while ( $bytes = sysread $new_sock, $buf1, $readlen ) {
			$tmpStr .= $buf1;
			last CHUNK if length($buf1) < $readlen;
		}
		print "$tmpStr\n";
		sendtomysql($_);

		exit(0);
	} else {
		#close off connection, already passed on to child
		$new_sock->close;
	}
}

sub sendtomysql {
	my $data = $_;
	chomp($data);
	# 0908242216,0033663282263,GPRMC,212442.000,A,4849.0475,N,00219.4763,E,2.29,,220809,,,A*70,F,imei:359587017313647,101Q,
	my @datas = split(/,/, $data);
	$dbh = DBI->connect('DBI:mysql:dbname', 'dbuser', 'dbpass') || die "Could not connect to database: $DBI::errstr";
	
	my $trackerdate 			= $dbh->quote($datas[0]);
	my $phone 				= $dbh->quote($datas[1]);
	my $gprmc 				= $dbh->quote($datas[2]);
	my $satelliteDerivedTime 		= $dbh->quote($datas[3]);
	my $satelliteFixStatus 			= $dbh->quote($datas[4]);
	my $latitudeDecimalDegrees	 	= $dbh->quote($datas[5]);
	my $latitudeHemisphere 			= $dbh->quote($datas[6]);
	my $longitudeDecimalDegrees 		= $dbh->quote($datas[7]);
	my $longitudeHemisphere 		= $dbh->quote($datas[8]);
	my $speed 				= $dbh->quote($datas[9]);
	my $bearing 				= $dbh->quote($datas[10]);
	my $utcDate 				= $dbh->quote($datas[11]);
	# = $datas[12];
	# = $datas[13];
	my $checksum 				= $dbh->quote($datas[14]);
	my $gpsSignalIndicator 			= $dbh->quote($datas[15]);
	if($datas[16] =~ /imei/) {
		$imei 				= $datas[16];
		$other 				= $dbh->quote($datas[17].' '.$datas[18]);
	} else {
		$imei 				= $datas[17];
		$other 				= $dbh->quote($datas[18].' '.$datas[19]);
	}
	
	my $imei = $dbh->quote(substr($imei,5));

	#print "INSERT INTO gprmc (ddate, imei, phone, trackerdate, satelliteDerivedTime, satelliteFixStatus, latitudeDecDeg, latitudeHemis, longitudeDecDeg, longitudeHemis, speed, bearing, utcDate, checksum, gpsSignalIndicator, other) VALUES (now(), $imei, $phone, $trackerdate, $satelliteDerivedTime, $satelliteFixStatus, $latitudeDecimalDegrees, $latitudeHemisphere, $longitudeDecimalDegrees, $longitudeHemisphere, $speed, $bearing, $utcDate, $checksum, $gpsSignalIndicator, $other)";
	if($gpsSignalIndicator == "'F'") {

		$dbh->do("INSERT INTO gprmc (ddate, imei, phone, trackerdate, satelliteDerivedTime, satelliteFixStatus, latitudeDecDeg, latitudeHemis, longitudeDecDeg, longitudeHemis, speed, bearing, utcDate, checksum, gpsSignalIndicator, other) VALUES (now(), $imei, $phone, $trackerdate, $satelliteDerivedTime, $satelliteFixStatus, $latitudeDecimalDegrees, $latitudeHemisphere, $longitudeDecimalDegrees, $longitudeHemisphere, $speed, $bearing, $utcDate, $checksum, $gpsSignalIndicator, $other)");

		$dbh->disconnect();
	}
	else {
		print $gpsSignalIndicator;
	}
	exit(0);
}

